#include<iostream>
using namespace std;

void displayGameBoard(int xMoves, int oMoves)
{
	//display the gameboard
	system("cls");
	for (int i = 1;i <= 9;i++)
	{
		if ((xMoves & (int)pow(2, i)) == pow(2, i))
		{
			cout << 'X';
		}
		else if ((oMoves & (int)pow(2, i)) == pow(2, i))
		{
			cout << 'O';
		}
		else
		{
			cout << i;
		}
		if (i == 1 || i == 2 || i == 4 || i == 5 || i == 7 || i == 8)
		{
			cout << "|";
		}
		else if (i != 9)
		{
			cout << "\n-----\n";
		}
	}
	cout << endl;
}

bool moveAlreadyAtPosition(int currentMove, int allMoves)
{
	bool result = false;

	if (((int)pow(2, currentMove) & allMoves) > 0)
	{
		result = true;
		cout << "Cheating is not allowed\n";
	}

	return result;
}

int getMove(char currentPlayer, int xMoves, int oMoves)
{
	int currentMove = 0;
	cout << currentPlayer << "'s move" << endl;
	do
	{
		cout << ">";
		cin >> currentMove;
	} while (currentMove < 1 || currentMove > 9 ||
		moveAlreadyAtPosition(currentMove, xMoves | oMoves));
	
	return currentMove;
}

void applyMove(char currentPlayer, int currentMove, int& xMoves, int& oMoves)
{
	if (currentPlayer == 'X')
	{
		xMoves += pow(2, currentMove);
	}
	else
	{
		oMoves += pow(2, currentMove);
	}
}

void checkForWinner(bool& gameOver, int xMoves, int oMoves)
{
	if ((xMoves & 14) == 14 ||
		(xMoves & 112) == 112 ||
		(xMoves & 896) == 896 ||
		(xMoves & 546) == 546 ||
		(xMoves & 584) == 584 ||
		(xMoves & 292) == 292 ||
		(xMoves & 146) == 146 ||
		(xMoves & 168) == 168)
	{
		cout << "X wins" << endl;
		gameOver = true;
	}
	else if ((oMoves & 14) == 14 ||
		(oMoves & 112) == 112 ||
		(oMoves & 896) == 896 ||
		(oMoves & 546) == 546 ||
		(oMoves & 584) == 584 ||
		(oMoves & 292) == 292 ||
		(oMoves & 146) == 146 ||
		(oMoves & 168) == 168)
	{
		cout << "O wins" << endl;
		gameOver = true;
	}
	else if (((oMoves | xMoves) & 1022) == 1022)
	{
		cout << "CAT wins" << endl;
		gameOver = true;
	}
}

void main()
{
	int xMoves = 0;
	int oMoves = 0;
	char currentPlayer = 'X';
	bool gameOver = false;
	while (!gameOver)
	{
		displayGameBoard(xMoves,oMoves);
		int currentMove = getMove(currentPlayer, xMoves,oMoves);
		applyMove(currentPlayer,currentMove,xMoves,oMoves);

		//change whose turn it is
		(currentPlayer == 'X') ? currentPlayer = 'O' : currentPlayer = 'X';
		//check for a winner
		checkForWinner(gameOver, xMoves, oMoves);
	}

}